%% efficiency_estimation

%-----------------------------------------------------------------------
% function to estimate efficiency for M&M2017 data set
%
% Author:   Sandra Iglesias
% Created:  2017-11-12
% Copyright (C) 2017 Institute for Biomedical Engineering
%                    University of Zurich and ETH Zurich
%-----------------------------------------------------------------------

SPM = load('E:\Documents_E\Seminars\M&M_Mantelstudium2017\MandM\MethodsAndModels\2017\Data\Results0001\Sub03\glm\Level1_0001\SPM.mat');
SPM = SPM.SPM;

% define design matrix for block (X1) and event-related design (X2)
% after pre-whitening and filtering
X1 = SPM.xX.xKXs.X(:,1:12);
X2 = SPM.xX.xKXs.X(:,13:24);

% define contrast of interest
c = [1 0 0 -1 0 0 zeros(1,6)];

% compute efficiency:
eff1 = 1/(c*pinv(X1'*X1)*c');
eff2 = 1/(c*pinv(X2'*X2)*c');

% plot results
figure1 = figure;
colormap(summer);

% Create axes
axes1 = axes('Parent',figure1);
hold(axes1,'on');

eff = [eff1 eff2];
l{1} = 'block design'; l{2} = 'event design';

colormap(summer);
h1=bar([1],eff(1),'DisplayName','block design','FaceColor',[0.2 0.2 0.6]); hold on;
h2=bar([2],eff(2),'DisplayName','event design','FaceColor',[0.2 0.6 0.6]);
% Set the remaining axes properties
set(axes1,'XTick',[1 2]);
% Create legend
legend(axes1,'show');
title('design efficiency');
