%% code from F. Grepory Ashby, Statistical Analysis of fMRI Data, MIT Press (2011)
% do not distribute this code!!!

% page 172, MATLAB Box 7.1
function [V,x,group] = rfx_ffx_plot()
nsubs = 12; %number of subjects
ntrials = 10; %number of samples per subject

% population distribution with mean = 2 and group variance = 16
group = 2+4*randn(1,nsubs);

%draw samples
for i = 1:nsubs
    x(:,i)=group(i)*ones(ntrials,1)+.5*randn(ntrials,1);
end;

% ffx variance
M=mean(x);
s=std(x);

tx=[-10:0.1:15];
k=1/sqrt(2*pi);
figure;
fr = 1;
for i = 1:nsubs
    pdf=.5*(k/.5)*exp(-(tx-group(i)).^2/(2*.25));
    subplot(2,1,1);scatter(x(:,i),zeros(1,ntrials),84,'x','k');
    drawnow
    V(fr)=getframe
    fr = fr+1
    plot(tx,pdf); hold on;
    drawnow
    V(fr)=getframe
    fr = fr+1
end

% rfx variance
variance=s.^2;
pooledvar=mean(variance);

% ffx t-statistics
sfixed=sqrt(pooledvar);
tfixed=mean(M)/sqrt(pooledvar/nsubs);

% rfx t-statistics
srandom=std(M);
trandom=mean(M)/(srandom/sqrt(nsubs));


pdfg = (k/4)*exp(-(tx-2).^2/(2*16));
subplot(2,1,1);plot(tx,pdfg); axis([-10 15 0 .5]);
drawnow
V(fr)=getframe;
title(['t-value fixed:', num2str(tfixed) ,'  t-value random: ',num2str(trandom)]);
    stats_v = [sqrt(pooledvar);std(M); mean(M)];
    l = cell(1,2);
    l{1}='std fixed'; l{2}='std random'; l{3}='mean';
    colormap(summer(6));
    subplot(2,1,2);h=bar(stats_v);xticklabels(l);
    
% g=VideoWriter('RFX_FFX_Movie.avi');
% open(g)
% writeVideo(g,V)
% close(g)
% g.FrameRate = 0.8;  % Default 30
% open(g)
% writeVideo(g,V)
% close(g)



